#ifndef FILE_H
#define FILE_H

#include <sys/types.h>

#include <stdint.h>

#include "ext4.h"
#include "types.h"

enum file_type	mode2filetype(uint16_t);
const char	*filetype2str(enum file_type);

/* returns -1 (seek or read error) or SZ_BLOCK (success) */
int		read_block(int, uint64_t, uint8_t *);

/* return -1 (seek or read errror) or 0 (success) */
int		file_open(int, uint32_t, struct file *);
void		file_free(struct file *);

/* returns -1 (seek or read error), 0 (eof), or number of bytes read (> 0) */
ssize_t		file_read(struct file *, uint8_t *, size_t);

#endif
