#ifndef LOG_H
#define LOG_H

#include <stdint.h>

#define LOG_UNDEFINED	0xffff

struct log_entry;

/* constructors */
struct log_entry	*log_read(int);
struct log_entry	*log_init(const char *);

/* destructor */
void		log_free(struct log_entry *);

/* modifiers */
int		log_addlink(struct log_entry *, const char *);
void		log_addperm(struct log_entry *, uint16_t);
void		log_adduid(struct log_entry *, uint16_t);
void		log_addgid(struct log_entry *, uint16_t);

/* accessors */
const char	*log_getpath(const struct log_entry *);
const char	*log_getlink(const struct log_entry *);
uint16_t	log_getperm(const struct log_entry *);
uint16_t	log_getuid(struct log_entry *);
uint16_t	log_getgid(struct log_entry *);

int		log_write(int, struct log_entry *);

#endif
