#include <sys/types.h>
#include <sys/stat.h>

#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>

#include "save.h"

int main()
{
	const off_t HOME_INODE = 0x95523;
	const off_t ETC_INODE = 0xa03a1;

	char path[PATHLEN];

	off_t		size;
	const char	*name;
	int		fd;
	int		logfd;
	uint8_t		pretend;

	if ((fd = open("/dev/sda4", O_RDONLY)) == -1) {
		perror("main(): open device");
		return 1;
	}

	logfd = open("rescue.log", O_WRONLY | O_CREAT | O_EXCL,
	    S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
	if (logfd == -1) {
		perror("main(): open log file");
		close(fd);
		return 1;
	}

	size = 0;
	path[0] = '\0';
#if 1
	/* recursively grab HOME_INODE or ETC_INODE */
	pretend = 0;
	name = "incripshin";

	if (save_dir(fd, HOME_INODE, name, logfd, pretend, path,
	    &size) == -1) {
		fprintf(stderr, "error saving %s\n", name);
	}
	printf("size of %s: %lld\n", name, size);
#endif

#if 0
	/* grab a single file */
	if (save_file(fd, 0x99420, "testfile", logfd, 0, path, &size) == -1) {
		fprintf(stderr, "no dice\n");
	}
#endif

	close(logfd);
	close(fd);
	return 0;
}
